'****************************************************************
'*  Name    : Teller / Counter                                  *
'*  Author  : Coenen Stijn [Stynus]                             *
'*  Notice  : Licenced under Creative Commons                   *
'*          : Attribution-Noncommercial 2.0 Belgium Licence     *
'*          : http://creativecommons.org/licenses/by-nc/2.0/be/ *
'*  Date    : 22/08/2010                                        *
'*  Version : 1.0                                               *
'****************************************************************
Device 16F628A
Config BOREN_ON, PWRTE_ON, WDT_OFF, LVP_OFF, MCLRE_OFF, HS_OSC, CP_OFF, DATA_CP_OFF
Xtal                = 20
All_Digital         = true
PortB_Pullups       = true
On_Hardware_Interrupt GoTo ISR
'****************************************************************
Symbol  spanning    = PORTB.0
Symbol  leds        = PORTB
TRISB               = 1

Symbol  tellen      = PORTA.1
Symbol  Reset       = PORTA.0

Symbol  SchuifData  = PORTA.4
Symbol  SchuifKlok  = PORTA.3
Symbol  SchuifLatch = PORTA.2

TRISA               = %11100011

Symbol  digit0      = %11111101
Symbol  digit1      = %11111011
Symbol  digit2      = %11110111
Symbol  digit3      = %11101111
Symbol  digit4      = %11011111

Symbol  INTEDG      = OPTION_REG.6
Symbol  INTE        = INTCON.4
Symbol  INTF        = INTCON.1          ; RB0/INT External Interrupt Flag bit
Symbol  GIE         = INTCON.7          ;Bit 7 van INTCON register heet: Global Interrupt Enable
'****************************************************************
Dim     teller      As Dword
Dim     index       As Byte
Dim     displays[5] As Byte
Dim     temp        As Byte
Dim     telbit      As Byte
Clear
DelayMS 2000
'****************************************************************   
INTEDG              = 1               'Interrupt op steigende flank
INTE                = 1               'External Interrupt Enable bit
index               = PORTB           'Dummy voor bugfix
INTF                = 0   
GIE                 = 1
teller              = ERead 0
GoTo main
'****************************************************************
ISR:
    If INTF = 1 Then
        EWrite 0, [teller]
        While 1 = 1
            If spanning = 0 Then
                Context Restore 
            EndIf         
        Wend
    EndIf    
Context Restore   
'****************************************************************
'       a
'     #####
'     #   # 
'   f # g # b
'     #####
'     #   # 
'   e # d # c
'     #####
'0 = $20
'1 = $BA
'2 = $07  
'3 = $12
'4 = $9C
'5 = $50
'6 = $40
'7 = $3B
'8 = $00
'9 = $10
'****************************************************************
main:
While 1 = 1
    For index = 0 To 4
        displays[index] = Dig teller, index
    Next 
    
    '** 0 **     
    SHOut SchuifData, SchuifKlok, MsbFirst, [digit0 \ 8]                   
    GoSub latchen
    leds = LookUpL displays[0] , [$20,$BA, $07, $12, $98, $50, $40, $3B, $00, $10] 
    DelayUS 500
    leds = $FF  
    '** 1 **      
    SHOut SchuifData, SchuifKlok, MsbFirst, [digit1 \ 8]                          
    GoSub latchen   
    leds = LookUpL displays[1] , [$20,$BA, $07, $12, $98, $50, $40, $3B, $00, $10]
    DelayUS 500 
    leds = $FF   
    '** 2 **            
    SHOut SchuifData, SchuifKlok, MsbFirst, [digit2 \ 8]                        
    GoSub latchen   
    leds = LookUpL displays[2] , [$20,$BA, $07, $12, $98, $50, $40, $3B, $00, $10]
    DelayUS 500 
    leds = $FF    
    '** 3 **                                 
    SHOut SchuifData, SchuifKlok, MsbFirst, [digit3 \ 8]                      
    GoSub latchen   
    leds = LookUpL displays[3] , [$20,$BA, $07, $12, $98, $50, $40, $3B, $00, $10]
    DelayUS 500 
    leds = $FF    
    '** 4 **                                         
    SHOut SchuifData, SchuifKlok, MsbFirst, [digit4 \ 8]                       
    GoSub latchen   
    leds = LookUpL displays[4] , [$20,$BA, $07, $12, $98, $50, $40, $3B, $00, $10]
    DelayUS 500 
    leds = $FF   
    
    
    If tellen = 0 Then
        If telbit = 0 Then
            Inc teller
            DelayMS 2
        EndIf
        telbit = 1 
    Else
        telbit = 0
    EndIf
    
    If Reset = 0 Then
        teller = 0
    EndIf 
Wend

latchen:
    DelayUS 20
    High SchuifLatch
    DelayUS 20
    Low SchuifLatch  
Return
'****************************************************************
End
